searchData={"items":[{"type":"module","title":"AshPyro.Extensions.Resource","doc":"An Ash resource extension providing declarative configuration of user interfaces via AshPyro components.","ref":"AshPyro.Extensions.Resource.html"},{"type":"module","title":"DSL Documentation - AshPyro.Extensions.Resource","doc":"#","ref":"AshPyro.Extensions.Resource.html#module-dsl-documentation"},{"type":"module","title":"Index - AshPyro.Extensions.Resource","doc":"* pyro\n    * data_table\n      * action\n        * column\n      * action_type\n        * column\n    * form\n      * action\n        * field\n        * field_group\n          * field\n      * action_type\n        * field\n        * field_group\n          * field\n    * live_view\n      * page\n        * list\n        * show\n        * create\n        * update\n\n#","ref":"AshPyro.Extensions.Resource.html#module-index"},{"type":"module","title":"Docs - AshPyro.Extensions.Resource","doc":"","ref":"AshPyro.Extensions.Resource.html#module-docs"},{"type":"module","title":"pyro - AshPyro.Extensions.Resource","doc":"Configure the pyro dashboard for a given resource\n\n * [data_table](#module-data_table)\n   * action\n     * column\n   * action_type\n     * column\n * [form](#module-form)\n   * action\n     * field\n     * field_group\n       * field\n   * action_type\n     * field\n     * field_group\n       * field\n * [live_view](#module-live_view)\n   * page\n     * list\n     * show\n     * create\n     * update\n\n\n\n\n\n---\n\n\n\n\n\n#","ref":"AshPyro.Extensions.Resource.html#module-pyro"},{"type":"module","title":"data_table - AshPyro.Extensions.Resource","doc":"Configure the appearance of data tables in the `AshPyro.Extensions.Resource` extension.\n\n * [action](#module-action)\n   * column\n * [action_type](#module-action_type)\n   * column\n\n\n\n\n\n---\n\n* `:exclude` (list of `t:atom/0`) - The actions to exclude from data tables. The default value is `[]`.\n\n\n\n##","ref":"AshPyro.Extensions.Resource.html#module-data_table"},{"type":"module","title":"action - AshPyro.Extensions.Resource","doc":"Configure the appearance of the data table for specific action(s).\n\n     * column\n\n\n\n* `:class` - Customize data table classes.\n\n* `:default_display` (list of `t:atom/0`) - The columns to display by default. The default value is `[]`.\n\n* `:default_sort` - The columns to sort on by default. The default value is `nil`.\n\n* `:exclude` (list of `t:atom/0`) - The fields to exclude from columns. The default value is `[]`.\n\n* `:description` (`t:String.t/0`) - The description for this data table (defaults to action's description).\n\n* `:name` - Required. The action name(s) for this data table.\n\n* `:label` (`t:String.t/0`) - The label for this data table (defaults to capitalized name).\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-action"},{"type":"module","title":"column - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific data table column in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:cell_class` - Customize cell class.\n\n* `:class` - Customize header class.\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:label` (`t:String.t/0`) - The label of the column (defaults to capitalized name).\n\n* `:name` (`t:atom/0`) - Required. The name of the column.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:render_cell` (function of arity 1) -  The default value is `&AshPyro.Extensions.Resource.DataTable.Column.render_cell/1`.\n\n* `:sortable?` (`t:boolean/0`) - Set to false to disable sorting. Note: If it it is not technically sortable, it will automatically be set to false. The default value is `true`.\n\n* `:type` - The type of the the column. Valid values are :default The default value is `:default`.\n\n\n\n\n\n\n\n##","ref":"AshPyro.Extensions.Resource.html#module-column"},{"type":"module","title":"action_type - AshPyro.Extensions.Resource","doc":"Configure the default data table appearance for actions of type(s). Will be ignored by actions configured explicitly.\n\n     * column\n\n\n\n* `:class` - Customize data table classes.\n\n* `:default_display` (list of `t:atom/0`) - The columns to display by default. The default value is `[]`.\n\n* `:default_sort` - The columns to sort on by default. The default value is `nil`.\n\n* `:exclude` (list of `t:atom/0`) - The fields to exclude from columns. The default value is `[]`.\n\n* `:exclude` (list of `t:atom/0`) - The fields to exclude from columns. The default value is `[]`.\n\n* `:name` - Required. The action type(s) for this data table.\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-action_type"},{"type":"module","title":"column - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific data table column in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:cell_class` - Customize cell class.\n\n* `:class` - Customize header class.\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:label` (`t:String.t/0`) - The label of the column (defaults to capitalized name).\n\n* `:name` (`t:atom/0`) - Required. The name of the column.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:render_cell` (function of arity 1) -  The default value is `&AshPyro.Extensions.Resource.DataTable.Column.render_cell/1`.\n\n* `:sortable?` (`t:boolean/0`) - Set to false to disable sorting. Note: If it it is not technically sortable, it will automatically be set to false. The default value is `true`.\n\n* `:type` - The type of the the column. Valid values are :default The default value is `:default`.\n\n\n\n\n\n\n\n\n\n\n#","ref":"AshPyro.Extensions.Resource.html#module-column"},{"type":"module","title":"form - AshPyro.Extensions.Resource","doc":"Configure the appearance of forms in the `AshPyro.Extensions.Resource` extension.\n\n * [action](#module-action)\n   * field\n   * field_group\n     * field\n * [action_type](#module-action_type)\n   * field\n   * field_group\n     * field\n\n\n\n\n\n---\n\n* `:exclude` (list of `t:atom/0`) - The actions to exclude from forms. The default value is `[]`.\n\n\n\n##","ref":"AshPyro.Extensions.Resource.html#module-form"},{"type":"module","title":"action - AshPyro.Extensions.Resource","doc":"Configure the appearance forms forms for specific action(s).\n\n     * field\n     * field_group\n       * field\n\n\n\n* `:name` - Required. The action name(s) for this form.\n\n* `:label` (`t:String.t/0`) - The label for this form (defaults to capitalized name).\n\n* `:description` (`t:String.t/0`) - The description for this form (defaults to action's description).\n\n* `:class` - Customize form classes.\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-action"},{"type":"module","title":"field - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific form field in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field to be modified\n\n* `:type` - The type of the value in the form. Valid values are :default, :long_text, :short_text, :autocomplete, :select, :nested_form The default value is `:default`.\n\n* `:options` (list of `t:term/0`) - The options for a select type input. The default value is `[]`.\n\n* `:label` (`t:String.t/0`) - The label of the field (defaults to capitalized name).\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:class` - Customize class.\n\n* `:input_class` - Customize input class.\n\n* `:autofocus` (`t:boolean/0`) - Autofocus the field. The default value is `false`.\n\n* `:prompt` (`t:String.t/0`) - Override the default prompt.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:autocomplete_search_action` (`t:atom/0`) - Set the autocomplete search action name. The default value is `:autocomplete`.\n\n* `:autocomplete_search_arg` (`t:atom/0`) - Set the autocomplete search argument key. The default value is `:search`.\n\n* `:autocomplete_option_label_key` (`t:atom/0`) - Override the default autocomplete key used as a label. The default value is `:label`.\n\n* `:autocomplete_option_value_key` (`t:atom/0`) - Override the default autocomplete key used as a value. The default value is `:id`.\n\n\n\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-field"},{"type":"module","title":"field_group - AshPyro.Extensions.Resource","doc":"Configure the appearance of form field groups in the `AshPyro.Extensions.Resource` extension.\n\n      * field\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field group.\n\n* `:label` (`t:String.t/0`) - The label of this group (defaults to capitalized name).\n\n* `:class` - Customize class.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n\n\n#####","ref":"AshPyro.Extensions.Resource.html#module-field_group"},{"type":"module","title":"field - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific form field in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field to be modified\n\n* `:type` - The type of the value in the form. Valid values are :default, :long_text, :short_text, :autocomplete, :select, :nested_form The default value is `:default`.\n\n* `:options` (list of `t:term/0`) - The options for a select type input. The default value is `[]`.\n\n* `:label` (`t:String.t/0`) - The label of the field (defaults to capitalized name).\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:class` - Customize class.\n\n* `:input_class` - Customize input class.\n\n* `:autofocus` (`t:boolean/0`) - Autofocus the field. The default value is `false`.\n\n* `:prompt` (`t:String.t/0`) - Override the default prompt.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:autocomplete_search_action` (`t:atom/0`) - Set the autocomplete search action name. The default value is `:autocomplete`.\n\n* `:autocomplete_search_arg` (`t:atom/0`) - Set the autocomplete search argument key. The default value is `:search`.\n\n* `:autocomplete_option_label_key` (`t:atom/0`) - Override the default autocomplete key used as a label. The default value is `:label`.\n\n* `:autocomplete_option_value_key` (`t:atom/0`) - Override the default autocomplete key used as a value. The default value is `:id`.\n\n\n\n\n\n\n\n\n##","ref":"AshPyro.Extensions.Resource.html#module-field"},{"type":"module","title":"action_type - AshPyro.Extensions.Resource","doc":"Configure default form appearance for actions of type(s). Will be ignored by actions configured explicitly.\n\n     * field\n     * field_group\n       * field\n\n\n\n* `:name` - Required. The action type(s) for this form.\n\n* `:class` - Customize form classes.\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-action_type"},{"type":"module","title":"field - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific form field in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field to be modified\n\n* `:type` - The type of the value in the form. Valid values are :default, :long_text, :short_text, :autocomplete, :select, :nested_form The default value is `:default`.\n\n* `:options` (list of `t:term/0`) - The options for a select type input. The default value is `[]`.\n\n* `:label` (`t:String.t/0`) - The label of the field (defaults to capitalized name).\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:class` - Customize class.\n\n* `:input_class` - Customize input class.\n\n* `:autofocus` (`t:boolean/0`) - Autofocus the field. The default value is `false`.\n\n* `:prompt` (`t:String.t/0`) - Override the default prompt.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:autocomplete_search_action` (`t:atom/0`) - Set the autocomplete search action name. The default value is `:autocomplete`.\n\n* `:autocomplete_search_arg` (`t:atom/0`) - Set the autocomplete search argument key. The default value is `:search`.\n\n* `:autocomplete_option_label_key` (`t:atom/0`) - Override the default autocomplete key used as a label. The default value is `:label`.\n\n* `:autocomplete_option_value_key` (`t:atom/0`) - Override the default autocomplete key used as a value. The default value is `:id`.\n\n\n\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-field"},{"type":"module","title":"field_group - AshPyro.Extensions.Resource","doc":"Configure the appearance of form field groups in the `AshPyro.Extensions.Resource` extension.\n\n      * field\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field group.\n\n* `:label` (`t:String.t/0`) - The label of this group (defaults to capitalized name).\n\n* `:class` - Customize class.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n\n\n#####","ref":"AshPyro.Extensions.Resource.html#module-field_group"},{"type":"module","title":"field - AshPyro.Extensions.Resource","doc":"Declare non-default behavior for a specific form field in the `AshPyro.Extensions.Resource` extension.\n\n\n\n\n\n* `:name` (`t:atom/0`) - Required. The name of the field to be modified\n\n* `:type` - The type of the value in the form. Valid values are :default, :long_text, :short_text, :autocomplete, :select, :nested_form The default value is `:default`.\n\n* `:options` (list of `t:term/0`) - The options for a select type input. The default value is `[]`.\n\n* `:label` (`t:String.t/0`) - The label of the field (defaults to capitalized name).\n\n* `:description` (`t:String.t/0`) - Override the default extracted description.\n\n* `:class` - Customize class.\n\n* `:input_class` - Customize input class.\n\n* `:autofocus` (`t:boolean/0`) - Autofocus the field. The default value is `false`.\n\n* `:prompt` (`t:String.t/0`) - Override the default prompt.\n\n* `:path` (list of `t:atom/0`) - Append to the root path (nested paths are appended).\n\n* `:autocomplete_search_action` (`t:atom/0`) - Set the autocomplete search action name. The default value is `:autocomplete`.\n\n* `:autocomplete_search_arg` (`t:atom/0`) - Set the autocomplete search argument key. The default value is `:search`.\n\n* `:autocomplete_option_label_key` (`t:atom/0`) - Override the default autocomplete key used as a label. The default value is `:label`.\n\n* `:autocomplete_option_value_key` (`t:atom/0`) - Override the default autocomplete key used as a value. The default value is `:id`.\n\n\n\n\n\n\n\n\n\n\n\n#","ref":"AshPyro.Extensions.Resource.html#module-field"},{"type":"module","title":"live_view - AshPyro.Extensions.Resource","doc":"Configure LiveViews in the `AshPyro.Extensions.Resource` extension.\n\n * [page](#module-page)\n   * list\n   * show\n   * create\n   * update\n\n\n\n\n\n---\n\n\n\n##","ref":"AshPyro.Extensions.Resource.html#module-live_view"},{"type":"module","title":"page - AshPyro.Extensions.Resource","doc":"Configure a page for this resource.\n\n     * list\n     * show\n     * create\n     * update\n\n\n\n* `:api` (`t:atom/0`) - Required. The API for routes on this page (can also specify per-route/per-action).\n\n* `:class` - Customize page classes.\n\n* `:keep_live?` (`t:boolean/0`) - Subscribe to resource updates and keep the view up to date. The default value is `false`.\n\n* `:name` (`t:atom/0`) - Required. The live action for this page.\n\n* `:path` (`t:String.t/0`) - Required. The route path for this page.\n\n* `:route_helper` (`t:atom/0`) - The route helper name to be generated. Defaults to [name]_path.\n\n* `:view_as` - The view style of the page:\n    - `:list_and_modal` - Always list view, show/create/edit in a modal\n    - `:show_and_modal` - List view for list actions, show as a dedicated view, create/edit in a modal on show\n    - `:individual` - All actions are a dedicated view\n   Valid values are :list_and_modal, :show_and_modal, :individual The default value is `:list_and_modal`.\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-page"},{"type":"module","title":"list - AshPyro.Extensions.Resource","doc":"Configure a list action for this resource.\n\n\n\n\n\n* `:path` (`t:String.t/0`) - Required. The route path for this action.\n\n* `:live_action` (`t:atom/0`) - Required. The live action for this action.\n\n* `:action` (`t:atom/0`) - Required. The action to use to load the records.\n\n* `:display_as` - How to display the action. Valid values are :data_table, :card_grid The default value is `:data_table`.\n\n* `:label` - The label for this action (defaults to humanized live_action).\n\n* `:description` - The description for this action.\n\n* `:class` - Customize action classes.\n\n\n\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-list"},{"type":"module","title":"show - AshPyro.Extensions.Resource","doc":"Configure a show action for this resource.\n\n\n\n\n\n* `:path` (`t:String.t/0`) - Required. The route path for this action.\n\n* `:live_action` (`t:atom/0`) - Required. The live action for this action.\n\n* `:action` (`t:atom/0`) - Required. The action to use to load the record.\n\n* `:display_as` - How to display the action. Valid values are :card The default value is `:card`.\n\n* `:label` - The label for this action (defaults to humanized live_action).\n\n* `:description` - The description for this action.\n\n* `:class` - Customize action classes.\n\n* `:identity` - The identity used to load the record. The default value is `:id`.\n\n\n\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-show"},{"type":"module","title":"create - AshPyro.Extensions.Resource","doc":"Configure a create action for this resource.\n\n\n\n\n\n* `:path` (`t:String.t/0`) - Required. The route path for this action.\n\n* `:live_action` (`t:atom/0`) - Required. The live action for this action.\n\n* `:action` (`t:atom/0`) - Required. The action to use to create the record.\n\n* `:display_as` - How to display the action. Valid values are :form The default value is `:form`.\n\n* `:label` - The label for this action (defaults to humanized live_action).\n\n* `:description` - The description for this action.\n\n* `:class` - Customize action classes.\n\n* `:identity` - The identity used to load the record. The default value is `:id`.\n\n\n\n\n\n\n####","ref":"AshPyro.Extensions.Resource.html#module-create"},{"type":"module","title":"update - AshPyro.Extensions.Resource","doc":"Configure a update action for this resource.\n\n\n\n\n\n* `:path` (`t:String.t/0`) - Required. The route path for this action.\n\n* `:live_action` (`t:atom/0`) - Required. The live action for this action.\n\n* `:action` (`t:atom/0`) - Required. The action to use to update the record.\n\n* `:load_action` (`t:atom/0`) - The action to use to load the record.\n\n* `:display_as` - How to display the action. Valid values are :form The default value is `:form`.\n\n* `:label` - The label for this action (defaults to humanized live_action).\n\n* `:description` - The description for this action.\n\n* `:class` - Customize action classes.\n\n* `:identity` - The identity used to load the record. The default value is `:id`.","ref":"AshPyro.Extensions.Resource.html#module-update"},{"type":"module","title":"AshPyro.Extensions.Resource.DataTable.Action","doc":"A data table for action(s) in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.DataTable.Action.html"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Action.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Action.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Action.get/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Action.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Action.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Action.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.DataTable.Action.t/0","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Action.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.DataTable.ActionType","doc":"A data table for action(s) of a given type in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.DataTable.ActionType.html"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.ActionType.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.ActionType.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.ActionType.get/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.ActionType.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.ActionType.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.ActionType.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.DataTable.ActionType.t/0","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.ActionType.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.DataTable.Column","doc":"The configuration of a data table column in the `AshPyro.Extensions.Resource` extension.\n\nBy default, the `tbody` cell will be rendered with `render_cell/1`. You can also change the `:type` option to specify special kinds of rendering.\n\nFor bespoke rendering needs, you can provide a custom component inline or as a function capture:\n\n```elixir\nimport Phoenix.Component, only: [sigil_H: 2]\ncolumn :code do\n  class \"whitespace-nowrap\"\n  render_cell fn assigns ->\n    ~H\"\"\"\n     \n    <%= Map.get(@row, @col[:name]) %>\n    \"\"\"\n  end\nend\n```","ref":"AshPyro.Extensions.Resource.DataTable.Column.html"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Column.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Column.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Column.get/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Column.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Column.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Column.html#get_and_update/3"},{"type":"function","title":"AshPyro.Extensions.Resource.DataTable.Column.render_cell/1","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Column.html#render_cell/1"},{"type":"type","title":"AshPyro.Extensions.Resource.DataTable.Column.t/0","doc":"","ref":"AshPyro.Extensions.Resource.DataTable.Column.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Form.Action","doc":"A form for action(s) in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.Form.Action.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Action.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.Form.Action.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Action.get/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.Action.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Action.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.Action.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.Form.Action.t/0","doc":"","ref":"AshPyro.Extensions.Resource.Form.Action.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Form.ActionType","doc":"A form for action(s) of a given type in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.Form.ActionType.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.ActionType.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.Form.ActionType.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.ActionType.get/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.ActionType.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.ActionType.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.ActionType.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.Form.ActionType.t/0","doc":"","ref":"AshPyro.Extensions.Resource.Form.ActionType.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Form.Field","doc":"The configuration of a form field in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.Form.Field.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Field.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.Form.Field.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Field.get/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.Field.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.Field.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.Field.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.Form.Field.field_type/0","doc":"","ref":"AshPyro.Extensions.Resource.Form.Field.html#t:field_type/0"},{"type":"type","title":"AshPyro.Extensions.Resource.Form.Field.t/0","doc":"","ref":"AshPyro.Extensions.Resource.Form.Field.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Form.FieldGroup","doc":"A group of form fields in the `AshPyro.Extensions.Resource` extension.","ref":"AshPyro.Extensions.Resource.Form.FieldGroup.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.FieldGroup.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.Form.FieldGroup.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.FieldGroup.get/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.FieldGroup.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.Form.FieldGroup.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.Form.FieldGroup.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.Form.FieldGroup.t/0","doc":"","ref":"AshPyro.Extensions.Resource.Form.FieldGroup.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Info","doc":"Helpers to introspect the `AshPyro.Extensions.Resource` Ash extension. Intended for use in components that automatically build UI from resource configuration.","ref":"AshPyro.Extensions.Resource.Info.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.data_table_for/2","doc":"Returns the data table defined in the `AshPyro.Extensions.Resource` extension for the given action.","ref":"AshPyro.Extensions.Resource.Info.html#data_table_for/2"},{"type":"function","title":"Examples - AshPyro.Extensions.Resource.Info.data_table_for/2","doc":"iex> data_table_for(AshPyro.Extensions.Resource.InfoTest.User, :list) |> Map.get(:name)\n    :list","ref":"AshPyro.Extensions.Resource.Info.html#data_table_for/2-examples"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.data_table_for!/2","doc":"Same as `&data_table_for2`, but raises if not found.","ref":"AshPyro.Extensions.Resource.Info.html#data_table_for!/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.form_for/2","doc":"Returns the form fields defined in the `AshPyro.Extensions.Resource` extension for the given action.","ref":"AshPyro.Extensions.Resource.Info.html#form_for/2"},{"type":"function","title":"Examples - AshPyro.Extensions.Resource.Info.form_for/2","doc":"iex> form_for(AshPyro.Extensions.Resource.InfoTest.User, :create) |> Map.get(:fields) |> Enum.map(& &1.name)\n    [:primary, :authorization, :friendships, :notes]","ref":"AshPyro.Extensions.Resource.Info.html#form_for/2-examples"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.form_for!/2","doc":"Same as `&form_for2`, but raises if not found.","ref":"AshPyro.Extensions.Resource.Info.html#form_for!/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.page_for/2","doc":"Returns the page defined in the `AshPyro.Extensions.Resource` extension for the given page name.","ref":"AshPyro.Extensions.Resource.Info.html#page_for/2"},{"type":"function","title":"Examples - AshPyro.Extensions.Resource.Info.page_for/2","doc":"iex> page_for(AshPyro.Extensions.Resource.InfoTest.User, :companies) |> Map.get(:name)\n    :companies","ref":"AshPyro.Extensions.Resource.Info.html#page_for/2-examples"},{"type":"function","title":"AshPyro.Extensions.Resource.Info.page_for!/2","doc":"Same as `&page_for2`, but raises if not found.","ref":"AshPyro.Extensions.Resource.Info.html#page_for!/2"},{"type":"module","title":"AshPyro.Extensions.Resource.LiveView.Page","doc":"A LiveView page.","ref":"AshPyro.Extensions.Resource.LiveView.Page.html"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.get/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.LiveView.Page.t/0","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.LiveView.Page.Create","doc":"A LiveView page.","ref":"AshPyro.Extensions.Resource.LiveView.Page.Create.html"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Create.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Create.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Create.get/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Create.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Create.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Create.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.LiveView.Page.Create.t/0","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Create.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.LiveView.Page.List","doc":"A LiveView page.","ref":"AshPyro.Extensions.Resource.LiveView.Page.List.html"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.List.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.List.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.List.get/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.List.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.List.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.List.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.LiveView.Page.List.t/0","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.List.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.LiveView.Page.Show","doc":"A LiveView page.","ref":"AshPyro.Extensions.Resource.LiveView.Page.Show.html"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Show.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Show.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Show.get/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Show.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Show.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Show.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.LiveView.Page.Show.t/0","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Show.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.LiveView.Page.Update","doc":"A LiveView page.","ref":"AshPyro.Extensions.Resource.LiveView.Page.Update.html"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Update.fetch/2","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Update.html#fetch/2"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Update.get/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Update.html#get/3"},{"type":"function","title":"AshPyro.Extensions.Resource.LiveView.Page.Update.get_and_update/3","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Update.html#get_and_update/3"},{"type":"type","title":"AshPyro.Extensions.Resource.LiveView.Page.Update.t/0","doc":"","ref":"AshPyro.Extensions.Resource.LiveView.Page.Update.html#t:t/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Router","doc":"Tooling to generate routes for AshPyro's LiveView page DSL.","ref":"AshPyro.Extensions.Resource.Router.html"},{"type":"macro","title":"AshPyro.Extensions.Resource.Router.live_routes_for/3","doc":"Generates live routes for a given LiveView, resource and page.\n\n```elixir\ndefmodule ExampleWeb.Router do\n  use ExampleWeb, :router\n  import AshPyro.Extensions.Resource.Router\n\n  # ...\n\n  scope \"/\", ExampleWeb do\n    pipe_through :browser\n\n    live_routes_for CompanyLive, Example.Company, :companies\n    end\n  end\nend\n```","ref":"AshPyro.Extensions.Resource.Router.html#live_routes_for/3"},{"type":"module","title":"AshPyro.Extensions.Resource.Schema","doc":"Shared types for resource extension schemas.","ref":"AshPyro.Extensions.Resource.Schema.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Schema.css_class_schema_type/0","doc":"schema type for CSS classes accepted by an Ash component","ref":"AshPyro.Extensions.Resource.Schema.html#css_class_schema_type/0"},{"type":"function","title":"AshPyro.Extensions.Resource.Schema.inheritable_schema_type/1","doc":"build an inheritable type","ref":"AshPyro.Extensions.Resource.Schema.html#inheritable_schema_type/1"},{"type":"function","title":"AshPyro.Extensions.Resource.Schema.sort_schema_type/0","doc":"acceptable formats for sorting options","ref":"AshPyro.Extensions.Resource.Schema.html#sort_schema_type/0"},{"type":"type","title":"AshPyro.Extensions.Resource.Schema.css_class/0","doc":"","ref":"AshPyro.Extensions.Resource.Schema.html#t:css_class/0"},{"type":"type","title":"AshPyro.Extensions.Resource.Schema.sort/0","doc":"","ref":"AshPyro.Extensions.Resource.Schema.html#t:sort/0"},{"type":"module","title":"AshPyro.Extensions.Resource.Transformers","doc":"Tooling for Ash resource transformation.","ref":"AshPyro.Extensions.Resource.Transformers.html"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.default_label/1","doc":"Extract a default humanized label from an entity name.","ref":"AshPyro.Extensions.Resource.Transformers.html#default_label/1"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.filter_actions/2","doc":"Get a filtered list of actions from the resource DSL.","ref":"AshPyro.Extensions.Resource.Transformers.html#filter_actions/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.get_action/2","doc":"Get a specific action from the resource DSL.","ref":"AshPyro.Extensions.Resource.Transformers.html#get_action/2"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.get_nested/3","doc":"Safely get nested values from maps or keyword lists that may be `nil` or an otherwise non-map value at any point. Great for accessing nested assigns in a template.","ref":"AshPyro.Extensions.Resource.Transformers.html#get_nested/3"},{"type":"function","title":"Examples - AshPyro.Extensions.Resource.Transformers.get_nested/3","doc":"iex> get_nested(nil, [:one, :two, :three])\n    nil\n\n    iex> get_nested(%{one: nil}, [:one, :two, :three])\n    nil\n\n    iex> get_nested(%{one: %{two: %{three: 3}}}, [:one, :two, :three])\n    3\n\n    iex> get_nested(%{one: %{two: [three: 3]}}, [:one, :two, :three])\n    3\n\n    iex> get_nested([one: :nope], [:one, :two, :three])\n    nil\n\n    iex> get_nested([one: :nope], [:one, :two, :three], :default)\n    :default","ref":"AshPyro.Extensions.Resource.Transformers.html#get_nested/3-examples"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.handle_errors/3","doc":"Collect all accumulated errors and log raise them all at once.","ref":"AshPyro.Extensions.Resource.Transformers.html#handle_errors/3"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.inherit_pyro_config/5","doc":"Inherit a value from another enitity by name.","ref":"AshPyro.Extensions.Resource.Transformers.html#inherit_pyro_config/5"},{"type":"function","title":"AshPyro.Extensions.Resource.Transformers.resource_field_type/2","doc":"Get the type of a resources field. Used to determine how to render it in the UI.","ref":"AshPyro.Extensions.Resource.Transformers.html#resource_field_type/2"},{"type":"extras","title":"About","doc":"# About\n\nPyro is a suite of libraries for building UI in Phoenix.\n\n- [Pyro](https://hexdocs.pm/pyro)\n\n  Component tooling for Phoenix.\n\n  - Customizable \"overrides\" system for granularly customizable themes\n  - Extended component attributes, e.g. CSS merging\n\n- [PyroComponents](https://hexdocs.pm/pyro_components)\n\n  Ready-made Phoenix components, built with pyro.\n\n  - Heex component library\n  - Overrides presets to get started quickly while allowing deep customization\n\n- [AshPyro](https://hexdocs.pm/ash_pyro)\n\n  Declarative UI for Ash Framework.\n\n  - Ash extensions providing a declarative UI DSL\n\n- [AshPyroComponents](https://hexdocs.pm/ash_pyro_components)\n\n  Components that automatically render PyroComponents declaratively via AshPyro.\n\nTo install AshPyro and add declarative UI DSL to your Ash project, follow the [Get Started](get-started.html) guide. For the other features, please see the \"Get Started\" guide for the appropriate library instead.","ref":"about.html"},{"type":"extras","title":"What \"problem\" is it solving? - About","doc":"The default model of Phoenix is to generate, then customize. While this does provide great isolation, I have found it pretty tedious to repeatedly make very similar copy & paste boilerplate changes to the generated code every time I create a new Phoenix app. Additionally, some things (like timezone localization) are quite complicated and it would be nice for them to be handled by a library that is updated with future improvements. Copy & pasting boilerplate will lead to maintenance burdens down the road.\n\nThe tricky part is handling all the bespoke features in each app while sharing as much as possible. The goal is to provide a wide array of tooling, helpers and components with sane defaults, while allowing very granular overrides and optional libraries. By separating each level of features, you can choose which parts of Pyro to leverage, and which to implement yourself.","ref":"about.html#what-problem-is-it-solving"},{"type":"extras","title":"Get Started","doc":"# Get Started\n\nThis guide steps through the installation process for AshPyro.","ref":"get-started.html"},{"type":"extras","title":"Installation - Get Started","doc":"The installation process is pretty straightforward.\n\n#","ref":"get-started.html#installation"},{"type":"extras","title":"Steps - Get Started","doc":"These steps assume you are adding AshPyro to an existing Phoenix LiveView app, as generated from the most recent version of `phx.new`. It also assumes you understand how to install and use Ash, and does not cover its installation or configuration.\n\n1. Add the appropriate dependencies:\n\n   ```elixir\n   def deps do\n     [\n    {:ash_postgres, \"~> 1.0\"},\n    {:ash_pyro, \"~> 0.0.0\"},\n    {:ash, \"~> 2.4\"},\n     ]\n   end\n   ```\n\n2. Compare your `.formatter.exs` to this example and add anything you are missing:\n\n   ```elixir\n   [\n     import_deps: [:phoenix, :ash_pyro, :ash, :ash_postgres],\n     subdirectories: [\"priv/*/migrations\"],\n     plugins: [Spark.Formatter, Phoenix.LiveView.HTMLFormatter],\n     inputs: [\"*.{heex,ex,exs}\", \"{config,lib,test}/**/*.{heex,ex,exs}\"]\n   ]\n   ```","ref":"get-started.html#steps"}],"content_type":"text/markdown"}